package com.gamingmesh.jobs.config;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import org.bukkit.Bukkit;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.YamlConfiguration;
import com.gamingmesh.jobs.Jobs;
import com.gamingmesh.jobs.container.JobInfo;
import com.gamingmesh.jobs.container.LocaleReader;
import com.gamingmesh.jobs.container.NameList;
import com.gamingmesh.jobs.stuff.ChatColor;

public class NameTranslatorManager {

    private Jobs plugin;

    public ArrayList<NameList> ListOfNames = new ArrayList<NameList>();
    public ArrayList<NameList> ListOfEntities = new ArrayList<NameList>();
    public ArrayList<NameList> ListOfEnchants = new ArrayList<NameList>();
    public ArrayList<NameList> ListOfColors = new ArrayList<NameList>();

    public NameTranslatorManager(Jobs plugin) {
	this.plugin = plugin;
    }

    public String Translate(String materialName, JobInfo info) {

	// Translating name to user friendly
	if (Jobs.getGCManager().UseCustomNames)
	    switch (info.getActionType()) {
	    case BREAK:
	    case TNTBREAK:
	    case EAT:
	    case CRAFT:
	    case DYE:
	    case PLACE:
	    case SMELT:
	    case REPAIR:
	    case BREW:
	    case FISH:
		for (NameList one : ListOfNames) {
		    String ids = one.getId() + ":" + one.getMeta();
		    if (!one.getMeta().equalsIgnoreCase("") && ids.equalsIgnoreCase(info.getId() + ":" + info.getMeta()) && !one.getId().equalsIgnoreCase("0")) {
			return one.getName();
		    }
		}
		for (NameList one : ListOfNames) {
		    String ids = one.getId();
		    if (ids.equalsIgnoreCase(String.valueOf(info.getId())) && !one.getId().equalsIgnoreCase("0")) {
			return one.getName();
		    }
		}
		break;
	    case BREED:
	    case KILL:
	    case MILK:
	    case TAME:
		for (NameList one : ListOfEntities) {
		    String ids = one.getId() + ":" + one.getMeta();
		    if (!one.getMeta().equalsIgnoreCase("") && ids.equalsIgnoreCase(info.getId() + ":" + info.getMeta()) && !one.getId().equalsIgnoreCase("0")) {
			return one.getName();
		    }
		}
		for (NameList one : ListOfEntities) {
		    String ids = one.getId();
		    if (ids.equalsIgnoreCase(String.valueOf(info.getId())) && !one.getId().equalsIgnoreCase("0")) {
			return materialName = one.getName();
		    }
		}
		break;
	    case ENCHANT:
		for (NameList one : ListOfEnchants) {
		    String ids = one.getId();
		    if (ids.equalsIgnoreCase(String.valueOf(info.getId()))) {
			return one.getName() + " " + info.getMeta();
		    }
		}
		for (NameList one : ListOfNames) {
		    String ids = one.getId() + ":" + one.getMeta();
		    if (!one.getMeta().equalsIgnoreCase("") && ids.equalsIgnoreCase(info.getId() + ":" + info.getMeta()) && !one.getId().equalsIgnoreCase("0")) {
			return one.getName();
		    }
		}
		for (NameList one : ListOfNames) {
		    String ids = one.getId();
		    if (ids.equalsIgnoreCase(String.valueOf(info.getId())) && !one.getId().equalsIgnoreCase("0")) {
			return one.getName();
		    }
		}
		break;
	    case CUSTOMKILL:
	    case MMKILL:
	    case EXPLORE:
		break;
	    case SHEAR:
		for (NameList one : ListOfColors) {
		    String ids = one.getMinecraftName();
		    if (ids.equalsIgnoreCase(String.valueOf(info.getName()))) {
			return one.getName();
		    }
		}
		break;
	    }

	return materialName;
    }

    public void readFile() {
	YmlMaker ItemFile = new YmlMaker(plugin, "TranslatableWords" + File.separator + "Words_" + Jobs.getGCManager().localeString + ".yml");
	ItemFile.saveDefaultConfig();
	ConfigurationSection section = ItemFile.getConfig().getConfigurationSection("ItemList");
	Set<String> keys = section.getKeys(false);
	ListOfNames.clear();
	for (String one : keys) {
	    String id = one.contains(":") ? one.split(":")[0] : one;
	    String meta = one.contains(":") ? one.split(":")[1] : "";
	    String MCName = section.getString(one + ".MCName");
	    String Name = section.getString(one + ".Name");
	    ListOfNames.add(new NameList(id, meta, Name, MCName));
	}

	Bukkit.getConsoleSender().sendMessage(ChatColor.YELLOW + "[Jobs] Loaded " + ListOfNames.size() + " custom item names!");

	section = ItemFile.getConfig().getConfigurationSection("EntityList");
	keys = section.getKeys(false);
	ListOfEntities.clear();
	for (String one : keys) {
	    String id = one.contains(":") ? one.split(":")[0] : one;
	    String meta = one.contains(":") ? one.split(":")[1] : "";
	    String MCName = section.getString(one + ".MCName");
	    String Name = section.getString(one + ".Name");
	    ListOfEntities.add(new NameList(id, meta, Name, MCName));
	}
	Bukkit.getConsoleSender().sendMessage(ChatColor.YELLOW + "[Jobs] Loaded " + ListOfEntities.size() + " custom entity names!");

	section = ItemFile.getConfig().getConfigurationSection("EnchantList");
	keys = section.getKeys(false);
	ListOfEnchants.clear();
	for (String one : keys) {
	    String id = one.contains(":") ? one.split(":")[0] : one;
	    String meta = one.contains(":") ? one.split(":")[1] : "";
	    String MCName = section.getString(one + ".MCName");
	    String Name = section.getString(one + ".Name");
	    ListOfEnchants.add(new NameList(id, meta, Name, MCName));
	}
	Bukkit.getConsoleSender().sendMessage(ChatColor.YELLOW + "[Jobs] Loaded " + ListOfEnchants.size() + " custom enchant names!");

	section = ItemFile.getConfig().getConfigurationSection("ColorList");
	keys = section.getKeys(false);
	ListOfColors.clear();
	for (String one : keys) {
	    String id = one.contains(":") ? one.split(":")[0] : one;
	    String meta = one.contains(":") ? one.split(":")[1] : "";
	    String MCName = section.getString(one + ".MCName");
	    String Name = section.getString(one + ".Name");
	    ListOfColors.add(new NameList(id, meta, Name, MCName));
	}
	Bukkit.getConsoleSender().sendMessage(ChatColor.YELLOW + "[Jobs] Loaded " + ListOfColors.size() + " custom color names!");
    }

    synchronized void load() {

	File file = new File(plugin.getDataFolder(), "TranslatableWords.yml");
	File file2 = new File(plugin.getDataFolder(), "TranslatableWords" + File.separator + "Words_" + Jobs.getGCManager().localeString + ".yml");
	if (file.exists())
	    file.renameTo(file2);

	// Just copying default language files, except en, that one will be generated
	List<String> languages = new ArrayList<String>();
	languages.add("fr");

	for (String lang : languages) {
	    YmlMaker langFile = new YmlMaker(plugin, "TranslatableWords" + File.separator + "Words_" + lang + ".yml");
	    langFile.saveDefaultConfig();
	}

	languages.add("en");

	File customLocaleFile = new File(plugin.getDataFolder(), "TranslatableWords" + File.separator + "Words_" + Jobs.getGCManager().localeString + ".yml");
	if (!customLocaleFile.exists() && !Jobs.getGCManager().localeString.equalsIgnoreCase("en"))
	    languages.add(Jobs.getGCManager().localeString);

	for (String lang : languages) {

	    File f = new File(plugin.getDataFolder(), "TranslatableWords" + File.separator + "Words_" + lang + ".yml");
	    YamlConfiguration config = YamlConfiguration.loadConfiguration(f);
	    CommentedYamlConfiguration writer = new CommentedYamlConfiguration();

	    LocaleReader c = new LocaleReader(config, writer);

	    c.getC().options().copyDefaults(true);

	    c.get("ItemList.0.MCName", "air");
	    c.get("ItemList.0.Name", "Air");
	    c.get("ItemList.1.MCName", "stone");
	    c.get("ItemList.1.Name", "All Stone");
	    c.get("ItemList.1:0.MCName", "stone");
	    c.get("ItemList.1:0.Name", "Stone");
	    c.get("ItemList.1:1.MCName", "stone");
	    c.get("ItemList.1:1.Name", "Granite");
	    c.get("ItemList.1:2.MCName", "stone");
	    c.get("ItemList.1:2.Name", "Polished Granite");
	    c.get("ItemList.1:3.MCName", "stone");
	    c.get("ItemList.1:3.Name", "Diorite");
	    c.get("ItemList.1:4.MCName", "stone");
	    c.get("ItemList.1:4.Name", "Polished Diorite");
	    c.get("ItemList.1:5.MCName", "stone");
	    c.get("ItemList.1:5.Name", "Andesite");
	    c.get("ItemList.1:6.MCName", "stone");
	    c.get("ItemList.1:6.Name", "Polished Andesite");
	    c.get("ItemList.2.MCName", "grass");
	    c.get("ItemList.2.Name", "Grass");
	    c.get("ItemList.3.MCName", "dirt");
	    c.get("ItemList.3.Name", "All Dirt");
	    c.get("ItemList.3:0.MCName", "dirt");
	    c.get("ItemList.3:0.Name", "Dirt");
	    c.get("ItemList.3:1.MCName", "dirt");
	    c.get("ItemList.3:1.Name", "Coarse Dirt");
	    c.get("ItemList.3:2.MCName", "dirt");
	    c.get("ItemList.3:2.Name", "Podzol");
	    c.get("ItemList.4.MCName", "cobblestone");
	    c.get("ItemList.4.Name", "Cobblestone");
	    c.get("ItemList.5.MCName", "planks");
	    c.get("ItemList.5.Name", "All Wood Plank");
	    c.get("ItemList.5:0.MCName", "planks");
	    c.get("ItemList.5:0.Name", "Oak Wood Plank");
	    c.get("ItemList.5:1.MCName", "planks");
	    c.get("ItemList.5:1.Name", "Spruce Wood Plank");
	    c.get("ItemList.5:2.MCName", "planks");
	    c.get("ItemList.5:2.Name", "Birch Wood Plank");
	    c.get("ItemList.5:3.MCName", "planks");
	    c.get("ItemList.5:3.Name", "Jungle Wood Plank");
	    c.get("ItemList.5:4.MCName", "planks");
	    c.get("ItemList.5:4.Name", "Acacia Wood Plank");
	    c.get("ItemList.5:5.MCName", "planks");
	    c.get("ItemList.5:5.Name", "Dark Oak Wood Plank");
	    c.get("ItemList.6.MCName", "sapling");
	    c.get("ItemList.6.Name", "All Saplings");
	    c.get("ItemList.6:0.MCName", "sapling");
	    c.get("ItemList.6:0.Name", "Oak Sapling");
	    c.get("ItemList.6:1.MCName", "sapling");
	    c.get("ItemList.6:1.Name", "Spruce Sapling");
	    c.get("ItemList.6:2.MCName", "sapling");
	    c.get("ItemList.6:2.Name", "Birch Sapling");
	    c.get("ItemList.6:3.MCName", "sapling");
	    c.get("ItemList.6:3.Name", "Jungle Sapling");
	    c.get("ItemList.6:4.MCName", "sapling");
	    c.get("ItemList.6:4.Name", "Acacia Sapling");
	    c.get("ItemList.6:5.MCName", "sapling");
	    c.get("ItemList.6:5.Name", "Dark Oak Sapling");
	    c.get("ItemList.7.MCName", "bedrock");
	    c.get("ItemList.7.Name", "Bedrock");
	    c.get("ItemList.8.MCName", "flowing_water");
	    c.get("ItemList.8.Name", "Flowing Water");
	    c.get("ItemList.9.MCName", "water");
	    c.get("ItemList.9.Name", "Still Water");
	    c.get("ItemList.10.MCName", "flowing_lava");
	    c.get("ItemList.10.Name", "Flowing Lava");
	    c.get("ItemList.11.MCName", "lava");
	    c.get("ItemList.11.Name", "Still Lava");
	    c.get("ItemList.12.MCName", "sand");
	    c.get("ItemList.12.Name", "All Sand");
	    c.get("ItemList.12:0.MCName", "sand");
	    c.get("ItemList.12:0.Name", "Sand");
	    c.get("ItemList.12:1.MCName", "sand");
	    c.get("ItemList.12:1.Name", "Red Sand");
	    c.get("ItemList.13.MCName", "gravel");
	    c.get("ItemList.13.Name", "Gravel");
	    c.get("ItemList.14.MCName", "gold_ore");
	    c.get("ItemList.14.Name", "Gold Ore");
	    c.get("ItemList.15.MCName", "iron_ore");
	    c.get("ItemList.15.Name", "Iron Ore");
	    c.get("ItemList.16.MCName", "coal_ore");
	    c.get("ItemList.16.Name", "Coal Ore");
	    c.get("ItemList.17.MCName", "log");
	    c.get("ItemList.17.Name", "All Wood");
	    c.get("ItemList.17:0.MCName", "log");
	    c.get("ItemList.17:0.Name", "Oak Wood");
	    c.get("ItemList.17:1.MCName", "log");
	    c.get("ItemList.17:1.Name", "Spruce Wood");
	    c.get("ItemList.17:2.MCName", "log");
	    c.get("ItemList.17:2.Name", "Birch Wood");
	    c.get("ItemList.17:3.MCName", "log");
	    c.get("ItemList.17:3.Name", "Jungle Wood");
	    c.get("ItemList.18.MCName", "leaves");
	    c.get("ItemList.18.Name", "All Leaves");
	    c.get("ItemList.18:0.MCName", "leaves");
	    c.get("ItemList.18:0.Name", "Oak Leaves");
	    c.get("ItemList.18:1.MCName", "leaves");
	    c.get("ItemList.18:1.Name", "Spruce Leaves");
	    c.get("ItemList.18:2.MCName", "leaves");
	    c.get("ItemList.18:2.Name", "Birch Leaves");
	    c.get("ItemList.18:3.MCName", "leaves");
	    c.get("ItemList.18:3.Name", "Jungle Leaves");
	    c.get("ItemList.19.MCName", "sponge");
	    c.get("ItemList.19.Name", "Sponge");
	    c.get("ItemList.19:1.MCName", "sponge");
	    c.get("ItemList.19:1.Name", "Wet Sponge");
	    c.get("ItemList.20.MCName", "glass");
	    c.get("ItemList.20.Name", "Glass");
	    c.get("ItemList.21.MCName", "lapis_ore");
	    c.get("ItemList.21.Name", "Lapis Lazuli Ore");
	    c.get("ItemList.22.MCName", "lapis_block");
	    c.get("ItemList.22.Name", "Lapis Lazuli Block");
	    c.get("ItemList.23.MCName", "dispenser");
	    c.get("ItemList.23.Name", "Dispenser");
	    c.get("ItemList.24.MCName", "sandstone");
	    c.get("ItemList.24.Name", "Sandstone");
	    c.get("ItemList.24:1.MCName", "sandstone");
	    c.get("ItemList.24:1.Name", "Chiseled Sandstone");
	    c.get("ItemList.24:2.MCName", "sandstone");
	    c.get("ItemList.24:2.Name", "Smooth Sandstone");
	    c.get("ItemList.25.MCName", "noteblock");
	    c.get("ItemList.25.Name", "Note Block");
	    c.get("ItemList.26.MCName", "bed");
	    c.get("ItemList.26.Name", "Bed");
	    c.get("ItemList.27.MCName", "golden_rail");
	    c.get("ItemList.27.Name", "Powered Rail");
	    c.get("ItemList.28.MCName", "detector_rail");
	    c.get("ItemList.28.Name", "Detector Rail");
	    c.get("ItemList.29.MCName", "sticky_piston");
	    c.get("ItemList.29.Name", "Sticky Piston");
	    c.get("ItemList.30.MCName", "web");
	    c.get("ItemList.30.Name", "Cobweb");
	    c.get("ItemList.31.MCName", "tallgrass");
	    c.get("ItemList.31.Name", "Dead Shrub");
	    c.get("ItemList.31:1.MCName", "tallgrass");
	    c.get("ItemList.31:1.Name", "Grass");
	    c.get("ItemList.31:2.MCName", "tallgrass");
	    c.get("ItemList.31:2.Name", "Fern");
	    c.get("ItemList.32.MCName", "deadbush");
	    c.get("ItemList.32.Name", "Dead Shrub");
	    c.get("ItemList.33.MCName", "piston");
	    c.get("ItemList.33.Name", "Piston");
	    c.get("ItemList.34.MCName", "piston_head");
	    c.get("ItemList.34.Name", "Piston Head");
	    c.get("ItemList.35.MCName", "wool");
	    c.get("ItemList.35.Name", "All Wool");
	    c.get("ItemList.35:0.MCName", "wool");
	    c.get("ItemList.35:0.Name", "White Wool");
	    c.get("ItemList.35:1.MCName", "wool");
	    c.get("ItemList.35:1.Name", "Orange Wool");
	    c.get("ItemList.35:2.MCName", "wool");
	    c.get("ItemList.35:2.Name", "Magenta Wool");
	    c.get("ItemList.35:3.MCName", "wool");
	    c.get("ItemList.35:3.Name", "Light Blue Wool");
	    c.get("ItemList.35:4.MCName", "wool");
	    c.get("ItemList.35:4.Name", "Yellow Wool");
	    c.get("ItemList.35:5.MCName", "wool");
	    c.get("ItemList.35:5.Name", "Lime Wool");
	    c.get("ItemList.35:6.MCName", "wool");
	    c.get("ItemList.35:6.Name", "Pink Wool");
	    c.get("ItemList.35:7.MCName", "wool");
	    c.get("ItemList.35:7.Name", "Gray Wool");
	    c.get("ItemList.35:8.MCName", "wool");
	    c.get("ItemList.35:8.Name", "Light Gray Wool");
	    c.get("ItemList.35:9.MCName", "wool");
	    c.get("ItemList.35:9.Name", "Cyan Wool");
	    c.get("ItemList.35:10.MCName", "wool");
	    c.get("ItemList.35:10.Name", "Purple Wool");
	    c.get("ItemList.35:11.MCName", "wool");
	    c.get("ItemList.35:11.Name", "Blue Wool");
	    c.get("ItemList.35:12.MCName", "wool");
	    c.get("ItemList.35:12.Name", "Brown Wool");
	    c.get("ItemList.35:13.MCName", "wool");
	    c.get("ItemList.35:13.Name", "Green Wool");
	    c.get("ItemList.35:14.MCName", "wool");
	    c.get("ItemList.35:14.Name", "Red Wool");
	    c.get("ItemList.35:15.MCName", "wool");
	    c.get("ItemList.35:15.Name", "Black Wool");
	    c.get("ItemList.37.MCName", "yellow_flower");
	    c.get("ItemList.37.Name", "Dandelion");
	    c.get("ItemList.38.MCName", "red_flower");
	    c.get("ItemList.38.Name", "All Flowers");
	    c.get("ItemList.38:0.MCName", "red_flower");
	    c.get("ItemList.38:0.Name", "Poppy");
	    c.get("ItemList.38:1.MCName", "red_flower");
	    c.get("ItemList.38:1.Name", "Blue Orchid");
	    c.get("ItemList.38:2.MCName", "red_flower");
	    c.get("ItemList.38:2.Name", "Allium");
	    c.get("ItemList.38:3.MCName", "red_flower");
	    c.get("ItemList.38:3.Name", "Azure Bluet");
	    c.get("ItemList.38:4.MCName", "red_flower");
	    c.get("ItemList.38:4.Name", "Red Tulip");
	    c.get("ItemList.38:5.MCName", "red_flower");
	    c.get("ItemList.38:5.Name", "Orange Tulip");
	    c.get("ItemList.38:6.MCName", "red_flower");
	    c.get("ItemList.38:6.Name", "White Tulip");
	    c.get("ItemList.38:7.MCName", "red_flower");
	    c.get("ItemList.38:7.Name", "Pink Tulip");
	    c.get("ItemList.38:8.MCName", "red_flower");
	    c.get("ItemList.38:8.Name", "Oxeye Daisy");
	    c.get("ItemList.39.MCName", "brown_mushroom");
	    c.get("ItemList.39.Name", "Brown Mushroom");
	    c.get("ItemList.40.MCName", "red_mushroom");
	    c.get("ItemList.40.Name", "Red Mushroom");
	    c.get("ItemList.41.MCName", "gold_block");
	    c.get("ItemList.41.Name", "Gold Block");
	    c.get("ItemList.42.MCName", "iron_block");
	    c.get("ItemList.42.Name", "Iron Block");
	    c.get("ItemList.43.MCName", "double_stone_slab");
	    c.get("ItemList.43.Name", "All Double Slabs");
	    c.get("ItemList.43:0.MCName", "double_stone_slab");
	    c.get("ItemList.43:0.Name", "Double Stone Slab");
	    c.get("ItemList.43:1.MCName", "double_stone_slab");
	    c.get("ItemList.43:1.Name", "Double Sandstone Slab");
	    c.get("ItemList.43:2.MCName", "double_stone_slab");
	    c.get("ItemList.43:2.Name", "Double Wooden Slab");
	    c.get("ItemList.43:3.MCName", "double_stone_slab");
	    c.get("ItemList.43:3.Name", "Double Cobblestone Slab");
	    c.get("ItemList.43:4.MCName", "double_stone_slab");
	    c.get("ItemList.43:4.Name", "Double Brick Slab");
	    c.get("ItemList.43:5.MCName", "double_stone_slab");
	    c.get("ItemList.43:5.Name", "Double Stone Brick Slab");
	    c.get("ItemList.43:6.MCName", "double_stone_slab");
	    c.get("ItemList.43:6.Name", "Double Nether Brick Slab");
	    c.get("ItemList.43:7.MCName", "double_stone_slab");
	    c.get("ItemList.43:7.Name", "Double Quartz Slab");
	    c.get("ItemList.44.MCName", "stone_slab");
	    c.get("ItemList.44.Name", "All Slabs");
	    c.get("ItemList.44:0.MCName", "stone_slab");
	    c.get("ItemList.44:0.Name", "Stone Slab");
	    c.get("ItemList.44:1.MCName", "stone_slab");
	    c.get("ItemList.44:1.Name", "Sandstone Slab");
	    c.get("ItemList.44:2.MCName", "stone_slab");
	    c.get("ItemList.44:2.Name", "Wooden Slab");
	    c.get("ItemList.44:3.MCName", "stone_slab");
	    c.get("ItemList.44:3.Name", "Cobblestone Slab");
	    c.get("ItemList.44:4.MCName", "stone_slab");
	    c.get("ItemList.44:4.Name", "Brick Slab");
	    c.get("ItemList.44:5.MCName", "stone_slab");
	    c.get("ItemList.44:5.Name", "Stone Brick Slab");
	    c.get("ItemList.44:6.MCName", "stone_slab");
	    c.get("ItemList.44:6.Name", "Nether Brick Slab");
	    c.get("ItemList.44:7.MCName", "stone_slab");
	    c.get("ItemList.44:7.Name", "Quartz Slab");
	    c.get("ItemList.45.MCName", "brick_block");
	    c.get("ItemList.45.Name", "Bricks");
	    c.get("ItemList.46.MCName", "tnt");
	    c.get("ItemList.46.Name", "TNT");
	    c.get("ItemList.47.MCName", "bookshelf");
	    c.get("ItemList.47.Name", "Bookshelf");
	    c.get("ItemList.48.MCName", "mossy_cobblestone");
	    c.get("ItemList.48.Name", "Moss Stone");
	    c.get("ItemList.49.MCName", "obsidian");
	    c.get("ItemList.49.Name", "Obsidian");
	    c.get("ItemList.50.MCName", "torch");
	    c.get("ItemList.50.Name", "Torch");
	    c.get("ItemList.51.MCName", "fire");
	    c.get("ItemList.51.Name", "Fire");
	    c.get("ItemList.52.MCName", "mob_spawner");
	    c.get("ItemList.52.Name", "Monster Spawner");
	    c.get("ItemList.53.MCName", "oak_stairs");
	    c.get("ItemList.53.Name", "Oak Wood Stairs");
	    c.get("ItemList.54.MCName", "chest");
	    c.get("ItemList.54.Name", "Chest");
	    c.get("ItemList.55.MCName", "redstone_wire");
	    c.get("ItemList.55.Name", "Redstone Wire");
	    c.get("ItemList.56.MCName", "diamond_ore");
	    c.get("ItemList.56.Name", "Diamond Ore");
	    c.get("ItemList.57.MCName", "diamond_block");
	    c.get("ItemList.57.Name", "Diamond Block");
	    c.get("ItemList.58.MCName", "crafting_table");
	    c.get("ItemList.58.Name", "Crafting Table");
	    c.get("ItemList.59.MCName", "wheat");
	    c.get("ItemList.59.Name", "Wheat Crops");
	    c.get("ItemList.60.MCName", "farmland");
	    c.get("ItemList.60.Name", "Farmland");
	    c.get("ItemList.61.MCName", "furnace");
	    c.get("ItemList.61.Name", "Furnace");
	    c.get("ItemList.62.MCName", "lit_furnace");
	    c.get("ItemList.62.Name", "Burning Furnace");
	    c.get("ItemList.63.MCName", "standing_sign");
	    c.get("ItemList.63.Name", "Standing Sign Block");
	    c.get("ItemList.64.MCName", "wooden_door");
	    c.get("ItemList.64.Name", "Wooden Door Block");
	    c.get("ItemList.65.MCName", "ladder");
	    c.get("ItemList.65.Name", "Ladder");
	    c.get("ItemList.66.MCName", "rail");
	    c.get("ItemList.66.Name", "Rail");
	    c.get("ItemList.67.MCName", "stone_stairs");
	    c.get("ItemList.67.Name", "Cobblestone Stairs");
	    c.get("ItemList.68.MCName", "wall_sign");
	    c.get("ItemList.68.Name", "Wall-mounted Sign Block");
	    c.get("ItemList.69.MCName", "lever");
	    c.get("ItemList.69.Name", "Lever");
	    c.get("ItemList.70.MCName", "stone_pressure_plate");
	    c.get("ItemList.70.Name", "Stone Pressure Plate");
	    c.get("ItemList.71.MCName", "iron_door");
	    c.get("ItemList.71.Name", "Iron Door Block");
	    c.get("ItemList.72.MCName", "wooden_pressure_plate");
	    c.get("ItemList.72.Name", "Wooden Pressure Plate");
	    c.get("ItemList.73.MCName", "redstone_ore");
	    c.get("ItemList.73.Name", "Redstone Ore");
	    c.get("ItemList.74.MCName", "lit_redstone_ore");
	    c.get("ItemList.74.Name", "Glowing Redstone Ore");
	    c.get("ItemList.75.MCName", "unlit_redstone_torch");
	    c.get("ItemList.75.Name", "Redstone Torch (off)");
	    c.get("ItemList.76.MCName", "redstone_torch");
	    c.get("ItemList.76.Name", "Redstone Torch (on)");
	    c.get("ItemList.77.MCName", "stone_button");
	    c.get("ItemList.77.Name", "Stone Button");
	    c.get("ItemList.78.MCName", "snow_layer");
	    c.get("ItemList.78.Name", "Snow");
	    c.get("ItemList.79.MCName", "ice");
	    c.get("ItemList.79.Name", "Ice");
	    c.get("ItemList.80.MCName", "snow");
	    c.get("ItemList.80.Name", "Snow Block");
	    c.get("ItemList.81.MCName", "cactus");
	    c.get("ItemList.81.Name", "Cactus");
	    c.get("ItemList.82.MCName", "clay");
	    c.get("ItemList.82.Name", "Clay");
	    c.get("ItemList.83.MCName", "reeds");
	    c.get("ItemList.83.Name", "Sugar Canes");
	    c.get("ItemList.84.MCName", "jukebox");
	    c.get("ItemList.84.Name", "Jukebox");
	    c.get("ItemList.85.MCName", "fence");
	    c.get("ItemList.85.Name", "Oak Fence");
	    c.get("ItemList.86.MCName", "pumpkin");
	    c.get("ItemList.86.Name", "Pumpkin");
	    c.get("ItemList.87.MCName", "netherrack");
	    c.get("ItemList.87.Name", "Netherrack");
	    c.get("ItemList.88.MCName", "soul_sand");
	    c.get("ItemList.88.Name", "Soul Sand");
	    c.get("ItemList.89.MCName", "glowstone");
	    c.get("ItemList.89.Name", "Glowstone");
	    c.get("ItemList.90.MCName", "portal");
	    c.get("ItemList.90.Name", "Nether Portal");
	    c.get("ItemList.91.MCName", "lit_pumpkin");
	    c.get("ItemList.91.Name", "Jack o'Lantern");
	    c.get("ItemList.92.MCName", "cake");
	    c.get("ItemList.92.Name", "Cake Block");
	    c.get("ItemList.93.MCName", "unpowered_repeater");
	    c.get("ItemList.93.Name", "Redstone Repeater Block (off)");
	    c.get("ItemList.94.MCName", "powered_repeater");
	    c.get("ItemList.94.Name", "Redstone Repeater Block (on)");
	    c.get("ItemList.95.MCName", "stained_glass");
	    c.get("ItemList.95.Name", "All Stained Glass");
	    c.get("ItemList.95:0.MCName", "stained_glass");
	    c.get("ItemList.95:0.Name", "White Stained Glass");
	    c.get("ItemList.95:1.MCName", "stained_glass");
	    c.get("ItemList.95:1.Name", "Orange Stained Glass");
	    c.get("ItemList.95:2.MCName", "stained_glass");
	    c.get("ItemList.95:2.Name", "Magenta Stained Glass");
	    c.get("ItemList.95:3.MCName", "stained_glass");
	    c.get("ItemList.95:3.Name", "Light Blue Stained Glass");
	    c.get("ItemList.95:4.MCName", "stained_glass");
	    c.get("ItemList.95:4.Name", "Yellow Stained Glass");
	    c.get("ItemList.95:5.MCName", "stained_glass");
	    c.get("ItemList.95:5.Name", "Lime Stained Glass");
	    c.get("ItemList.95:6.MCName", "stained_glass");
	    c.get("ItemList.95:6.Name", "Pink Stained Glass");
	    c.get("ItemList.95:7.MCName", "stained_glass");
	    c.get("ItemList.95:7.Name", "Gray Stained Glass");
	    c.get("ItemList.95:8.MCName", "stained_glass");
	    c.get("ItemList.95:8.Name", "Light Gray Stained Glass");
	    c.get("ItemList.95:9.MCName", "stained_glass");
	    c.get("ItemList.95:9.Name", "Cyan Stained Glass");
	    c.get("ItemList.95:10.MCName", "stained_glass");
	    c.get("ItemList.95:10.Name", "Purple Stained Glass");
	    c.get("ItemList.95:11.MCName", "stained_glass");
	    c.get("ItemList.95:11.Name", "Blue Stained Glass");
	    c.get("ItemList.95:12.MCName", "stained_glass");
	    c.get("ItemList.95:12.Name", "Brown Stained Glass");
	    c.get("ItemList.95:13.MCName", "stained_glass");
	    c.get("ItemList.95:13.Name", "Green Stained Glass");
	    c.get("ItemList.95:14.MCName", "stained_glass");
	    c.get("ItemList.95:14.Name", "Red Stained Glass");
	    c.get("ItemList.95:15.MCName", "stained_glass");
	    c.get("ItemList.95:15.Name", "Black Stained Glass");
	    c.get("ItemList.96.MCName", "trapdoor");
	    c.get("ItemList.96.Name", "Wooden Trapdoor");
	    c.get("ItemList.97.MCName", "monster_egg");
	    c.get("ItemList.97.Name", "Stone Monster Egg");
	    c.get("ItemList.97:1.MCName", "monster_egg");
	    c.get("ItemList.97:1.Name", "Cobblestone Monster Egg");
	    c.get("ItemList.97:2.MCName", "monster_egg");
	    c.get("ItemList.97:2.Name", "Stone Brick Monster Egg");
	    c.get("ItemList.97:3.MCName", "monster_egg");
	    c.get("ItemList.97:3.Name", "Mossy Stone Brick Monster Egg");
	    c.get("ItemList.97:4.MCName", "monster_egg");
	    c.get("ItemList.97:4.Name", "Cracked Stone Brick Monster Egg");
	    c.get("ItemList.97:5.MCName", "monster_egg");
	    c.get("ItemList.97:5.Name", "Chiseled Stone Brick Monster Egg");
	    c.get("ItemList.98.MCName", "stonebrick");
	    c.get("ItemList.98.Name", "Stone Bricks");
	    c.get("ItemList.98:1.MCName", "stonebrick");
	    c.get("ItemList.98:1.Name", "Mossy Stone Bricks");
	    c.get("ItemList.98:2.MCName", "stonebrick");
	    c.get("ItemList.98:2.Name", "Cracked Stone Bricks");
	    c.get("ItemList.98:3.MCName", "stonebrick");
	    c.get("ItemList.98:3.Name", "Chiseled Stone Bricks");
	    c.get("ItemList.99.MCName", "brown_mushroom_block");
	    c.get("ItemList.99.Name", "Brown Mushroom Cap");
	    c.get("ItemList.100.MCName", "red_mushroom_block");
	    c.get("ItemList.100.Name", "Red Mushroom Cap");
	    c.get("ItemList.101.MCName", "iron_bars");
	    c.get("ItemList.101.Name", "Iron Bars");
	    c.get("ItemList.102.MCName", "glass_pane");
	    c.get("ItemList.102.Name", "Glass Pane");
	    c.get("ItemList.103.MCName", "melon_block");
	    c.get("ItemList.103.Name", "Melon Block");
	    c.get("ItemList.104.MCName", "pumpkin_stem");
	    c.get("ItemList.104.Name", "Pumpkin Stem");
	    c.get("ItemList.105.MCName", "melon_stem");
	    c.get("ItemList.105.Name", "Melon Stem");
	    c.get("ItemList.106.MCName", "vine");
	    c.get("ItemList.106.Name", "Vines");
	    c.get("ItemList.107.MCName", "fence_gate");
	    c.get("ItemList.107.Name", "Oak Fence Gate");
	    c.get("ItemList.108.MCName", "brick_stairs");
	    c.get("ItemList.108.Name", "Brick Stairs");
	    c.get("ItemList.109.MCName", "stone_brick_stairs");
	    c.get("ItemList.109.Name", "Stone Brick Stairs");
	    c.get("ItemList.110.MCName", "mycelium");
	    c.get("ItemList.110.Name", "Mycelium");
	    c.get("ItemList.111.MCName", "waterlily");
	    c.get("ItemList.111.Name", "Lily Pad");
	    c.get("ItemList.112.MCName", "nether_brick");
	    c.get("ItemList.112.Name", "Nether Brick");
	    c.get("ItemList.113.MCName", "nether_brick_fence");
	    c.get("ItemList.113.Name", "Nether Brick Fence");
	    c.get("ItemList.114.MCName", "nether_brick_stairs");
	    c.get("ItemList.114.Name", "Nether Brick Stairs");
	    c.get("ItemList.115.MCName", "nether_wart");
	    c.get("ItemList.115.Name", "Nether Wart");
	    c.get("ItemList.116.MCName", "enchanting_table");
	    c.get("ItemList.116.Name", "Enchantment Table");
	    c.get("ItemList.117.MCName", "brewing_stand");
	    c.get("ItemList.117.Name", "Brewing Stand");
	    c.get("ItemList.118.MCName", "cauldron");
	    c.get("ItemList.118.Name", "Cauldron");
	    c.get("ItemList.119.MCName", "end_portal");
	    c.get("ItemList.119.Name", "End Portal");
	    c.get("ItemList.120.MCName", "end_portal_frame");
	    c.get("ItemList.120.Name", "End Portal Frame");
	    c.get("ItemList.121.MCName", "end_stone");
	    c.get("ItemList.121.Name", "End Stone");
	    c.get("ItemList.122.MCName", "dragon_egg");
	    c.get("ItemList.122.Name", "Dragon Egg");
	    c.get("ItemList.123.MCName", "redstone_lamp");
	    c.get("ItemList.123.Name", "Redstone Lamp (inactive)");
	    c.get("ItemList.124.MCName", "lit_redstone_lamp");
	    c.get("ItemList.124.Name", "Redstone Lamp (active)");
	    c.get("ItemList.125.MCName", "double_wooden_slab");
	    c.get("ItemList.125.Name", "All Double Wood Slab");
	    c.get("ItemList.125:0.MCName", "double_wooden_slab");
	    c.get("ItemList.125:0.Name", "Double Oak Wood Slab");
	    c.get("ItemList.125:1.MCName", "double_wooden_slab");
	    c.get("ItemList.125:1.Name", "Double Spruce Wood Slab");
	    c.get("ItemList.125:2.MCName", "double_wooden_slab");
	    c.get("ItemList.125:2.Name", "Double Birch Wood Slab");
	    c.get("ItemList.125:3.MCName", "double_wooden_slab");
	    c.get("ItemList.125:3.Name", "Double Jungle Wood Slab");
	    c.get("ItemList.125:4.MCName", "double_wooden_slab");
	    c.get("ItemList.125:4.Name", "Double Acacia Wood Slab");
	    c.get("ItemList.125:5.MCName", "double_wooden_slab");
	    c.get("ItemList.125:5.Name", "Double Dark Oak Wood Slab");
	    c.get("ItemList.126.MCName", "wooden_slab");
	    c.get("ItemList.126.Name", "All Wood Slab");
	    c.get("ItemList.126:0.MCName", "wooden_slab");
	    c.get("ItemList.126:0.Name", "Oak Wood Slab");
	    c.get("ItemList.126:1.MCName", "wooden_slab");
	    c.get("ItemList.126:1.Name", "Spruce Wood Slab");
	    c.get("ItemList.126:2.MCName", "wooden_slab");
	    c.get("ItemList.126:2.Name", "Birch Wood Slab");
	    c.get("ItemList.126:3.MCName", "wooden_slab");
	    c.get("ItemList.126:3.Name", "Jungle Wood Slab");
	    c.get("ItemList.126:4.MCName", "wooden_slab");
	    c.get("ItemList.126:4.Name", "Acacia Wood Slab");
	    c.get("ItemList.126:5.MCName", "wooden_slab");
	    c.get("ItemList.126:5.Name", "Dark Oak Wood Slab");
	    c.get("ItemList.127.MCName", "cocoa");
	    c.get("ItemList.127.Name", "Cocoa");
	    c.get("ItemList.128.MCName", "sandstone_stairs");
	    c.get("ItemList.128.Name", "Sandstone Stairs");
	    c.get("ItemList.129.MCName", "emerald_ore");
	    c.get("ItemList.129.Name", "Emerald Ore");
	    c.get("ItemList.130.MCName", "ender_chest");
	    c.get("ItemList.130.Name", "Ender Chest");
	    c.get("ItemList.131.MCName", "tripwire_hook");
	    c.get("ItemList.131.Name", "Tripwire Hook");
	    c.get("ItemList.132.MCName", "tripwire_hook");
	    c.get("ItemList.132.Name", "Tripwire");
	    c.get("ItemList.133.MCName", "emerald_block");
	    c.get("ItemList.133.Name", "Emerald Block");
	    c.get("ItemList.134.MCName", "spruce_stairs");
	    c.get("ItemList.134.Name", "Spruce Wood Stairs");
	    c.get("ItemList.135.MCName", "birch_stairs");
	    c.get("ItemList.135.Name", "Birch Wood Stairs");
	    c.get("ItemList.136.MCName", "jungle_stairs");
	    c.get("ItemList.136.Name", "Jungle Wood Stairs");
	    c.get("ItemList.137.MCName", "command_block");
	    c.get("ItemList.137.Name", "Command Block");
	    c.get("ItemList.138.MCName", "beacon");
	    c.get("ItemList.138.Name", "Beacon");
	    c.get("ItemList.139.MCName", "cobblestone_wall");
	    c.get("ItemList.139.Name", "Cobblestone Wall");
	    c.get("ItemList.139:1.MCName", "cobblestone_wall");
	    c.get("ItemList.139:1.Name", "Mossy Cobblestone Wall");
	    c.get("ItemList.140.MCName", "flower_pot");
	    c.get("ItemList.140.Name", "Flower Pot");
	    c.get("ItemList.141.MCName", "carrots");
	    c.get("ItemList.141.Name", "Carrots");
	    c.get("ItemList.142.MCName", "potatoes");
	    c.get("ItemList.142.Name", "Potatoes");
	    c.get("ItemList.143.MCName", "wooden_button");
	    c.get("ItemList.143.Name", "Wooden Button");
	    c.get("ItemList.144.MCName", "skull");
	    c.get("ItemList.144.Name", "Mob Head");
	    c.get("ItemList.145.MCName", "anvil");
	    c.get("ItemList.145.Name", "Anvil");
	    c.get("ItemList.146.MCName", "trapped_chest");
	    c.get("ItemList.146.Name", "Trapped Chest");
	    c.get("ItemList.147.MCName", "light_weighted_pressure_plate");
	    c.get("ItemList.147.Name", "Weighted Pressure Plate (light)");
	    c.get("ItemList.148.MCName", "heavy_weighted_pressure_plate");
	    c.get("ItemList.148.Name", "Weighted Pressure Plate (heavy)");
	    c.get("ItemList.149.MCName", "unpowered_comparator");
	    c.get("ItemList.149.Name", "Redstone Comparator (inactive)");
	    c.get("ItemList.150.MCName", "powered_comparator");
	    c.get("ItemList.150.Name", "Redstone Comparator (active)");
	    c.get("ItemList.151.MCName", "daylight_detector");
	    c.get("ItemList.151.Name", "Daylight Sensor");
	    c.get("ItemList.152.MCName", "redstone_block");
	    c.get("ItemList.152.Name", "Redstone Block");
	    c.get("ItemList.153.MCName", "quartz_ore");
	    c.get("ItemList.153.Name", "Nether Quartz Ore");
	    c.get("ItemList.154.MCName", "hopper");
	    c.get("ItemList.154.Name", "Hopper");
	    c.get("ItemList.155.MCName", "quartz_block");
	    c.get("ItemList.155.Name", "Quartz Block");
	    c.get("ItemList.155:1.MCName", "quartz_block");
	    c.get("ItemList.155:1.Name", "Chiseled Quartz Block");
	    c.get("ItemList.155:2.MCName", "quartz_block");
	    c.get("ItemList.155:2.Name", "Pillar Quartz Block");
	    c.get("ItemList.156.MCName", "quartz_stairs");
	    c.get("ItemList.156.Name", "Quartz Stairs");
	    c.get("ItemList.157.MCName", "activator_rail");
	    c.get("ItemList.157.Name", "Activator Rail");
	    c.get("ItemList.158.MCName", "dropper");
	    c.get("ItemList.158.Name", "Dropper");
	    c.get("ItemList.159.MCName", "stained_hardened_clay");
	    c.get("ItemList.159.Name", "All Stained Clays");
	    c.get("ItemList.159:0.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:0.Name", "White Stained Clay");
	    c.get("ItemList.159:1.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:1.Name", "Orange Stained Clay");
	    c.get("ItemList.159:2.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:2.Name", "Magenta Stained Clay");
	    c.get("ItemList.159:3.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:3.Name", "Light Blue Stained Clay");
	    c.get("ItemList.159:4.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:4.Name", "Yellow Stained Clay");
	    c.get("ItemList.159:5.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:5.Name", "Lime Stained Clay");
	    c.get("ItemList.159:6.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:6.Name", "Pink Stained Clay");
	    c.get("ItemList.159:7.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:7.Name", "Gray Stained Clay");
	    c.get("ItemList.159:8.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:8.Name", "Light Gray Stained Clay");
	    c.get("ItemList.159:9.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:9.Name", "Cyan Stained Clay");
	    c.get("ItemList.159:10.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:10.Name", "Purple Stained Clay");
	    c.get("ItemList.159:11.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:11.Name", "Blue Stained Clay");
	    c.get("ItemList.159:12.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:12.Name", "Brown Stained Clay");
	    c.get("ItemList.159:13.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:13.Name", "Green Stained Clay");
	    c.get("ItemList.159:14.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:14.Name", "Red Stained Clay");
	    c.get("ItemList.159:15.MCName", "stained_hardened_clay");
	    c.get("ItemList.159:15.Name", "Black Stained Clay");
	    c.get("ItemList.160.MCName", "stained_glass_pane");
	    c.get("ItemList.160.Name", "All Stained Glass Panes");
	    c.get("ItemList.160:0.MCName", "stained_glass_pane");
	    c.get("ItemList.160:0.Name", "White Stained Glass Pane");
	    c.get("ItemList.160:1.MCName", "stained_glass_pane");
	    c.get("ItemList.160:1.Name", "Orange Stained Glass Pane");
	    c.get("ItemList.160:2.MCName", "stained_glass_pane");
	    c.get("ItemList.160:2.Name", "Magenta Stained Glass Pane");
	    c.get("ItemList.160:3.MCName", "stained_glass_pane");
	    c.get("ItemList.160:3.Name", "Light Blue Stained Glass Pane");
	    c.get("ItemList.160:4.MCName", "stained_glass_pane");
	    c.get("ItemList.160:4.Name", "Yellow Stained Glass Pane");
	    c.get("ItemList.160:5.MCName", "stained_glass_pane");
	    c.get("ItemList.160:5.Name", "Lime Stained Glass Pane");
	    c.get("ItemList.160:6.MCName", "stained_glass_pane");
	    c.get("ItemList.160:6.Name", "Pink Stained Glass Pane");
	    c.get("ItemList.160:7.MCName", "stained_glass_pane");
	    c.get("ItemList.160:7.Name", "Gray Stained Glass Pane");
	    c.get("ItemList.160:8.MCName", "stained_glass_pane");
	    c.get("ItemList.160:8.Name", "Light Gray Stained Glass Pane");
	    c.get("ItemList.160:9.MCName", "stained_glass_pane");
	    c.get("ItemList.160:9.Name", "Cyan Stained Glass Pane");
	    c.get("ItemList.160:10.MCName", "stained_glass_pane");
	    c.get("ItemList.160:10.Name", "Purple Stained Glass Pane");
	    c.get("ItemList.160:11.MCName", "stained_glass_pane");
	    c.get("ItemList.160:11.Name", "Blue Stained Glass Pane");
	    c.get("ItemList.160:12.MCName", "stained_glass_pane");
	    c.get("ItemList.160:12.Name", "Brown Stained Glass Pane");
	    c.get("ItemList.160:13.MCName", "stained_glass_pane");
	    c.get("ItemList.160:13.Name", "Green Stained Glass Pane");
	    c.get("ItemList.160:14.MCName", "stained_glass_pane");
	    c.get("ItemList.160:14.Name", "Red Stained Glass Pane");
	    c.get("ItemList.160:15.MCName", "stained_glass_pane");
	    c.get("ItemList.160:15.Name", "Black Stained Glass Pane");
	    c.get("ItemList.161.MCName", "leaves2");
	    c.get("ItemList.161.Name", "Acacia Or Dark Oak Leaves");
	    c.get("ItemList.161:0.MCName", "leaves2");
	    c.get("ItemList.161:0.Name", "Acacia Leaves");
	    c.get("ItemList.161:1.MCName", "leaves2");
	    c.get("ItemList.161:1.Name", "Dark Oak Leaves");
	    c.get("ItemList.162.MCName", "logs2");
	    c.get("ItemList.162.Name", "Acacia Or Dark Oak Wood");
	    c.get("ItemList.162:0.MCName", "logs2");
	    c.get("ItemList.162:0.Name", "Acacia Wood");
	    c.get("ItemList.162:1.MCName", "logs2");
	    c.get("ItemList.162:1.Name", "Dark Oak Wood");
	    c.get("ItemList.163.MCName", "acacia_stairs");
	    c.get("ItemList.163.Name", "Acacia Wood Stairs");
	    c.get("ItemList.164.MCName", "dark_oak_stairs");
	    c.get("ItemList.164.Name", "Dark Oak Wood Stairs");
	    c.get("ItemList.165.MCName", "slime");
	    c.get("ItemList.165.Name", "Slime Block");
	    c.get("ItemList.166.MCName", "barrier");
	    c.get("ItemList.166.Name", "Barrier");
	    c.get("ItemList.167.MCName", "iron_trapdoor");
	    c.get("ItemList.167.Name", "Iron Trapdoor");
	    c.get("ItemList.168.MCName", "prismarine");
	    c.get("ItemList.168.Name", "All Prismarine");
	    c.get("ItemList.168:0.MCName", "prismarine");
	    c.get("ItemList.168:0.Name", "Prismarine");
	    c.get("ItemList.168:1.MCName", "prismarine");
	    c.get("ItemList.168:1.Name", "Prismarine Bricks");
	    c.get("ItemList.168:2.MCName", "prismarine");
	    c.get("ItemList.168:2.Name", "Dark Prismarine");
	    c.get("ItemList.169.MCName", "sea_lantern");
	    c.get("ItemList.169.Name", "Sea Lantern");
	    c.get("ItemList.170.MCName", "hay_block");
	    c.get("ItemList.170.Name", "Hay Bale");
	    c.get("ItemList.171.MCName", "carpet");
	    c.get("ItemList.171.Name", "All Carpet");
	    c.get("ItemList.171:0.MCName", "carpet");
	    c.get("ItemList.171:0.Name", "White Carpet");
	    c.get("ItemList.171:1.MCName", "carpet");
	    c.get("ItemList.171:1.Name", "Orange Carpet");
	    c.get("ItemList.171:2.MCName", "carpet");
	    c.get("ItemList.171:2.Name", "Magenta Carpet");
	    c.get("ItemList.171:3.MCName", "carpet");
	    c.get("ItemList.171:3.Name", "Light Blue Carpet");
	    c.get("ItemList.171:4.MCName", "carpet");
	    c.get("ItemList.171:4.Name", "Yellow Carpet");
	    c.get("ItemList.171:5.MCName", "carpet");
	    c.get("ItemList.171:5.Name", "Lime Carpet");
	    c.get("ItemList.171:6.MCName", "carpet");
	    c.get("ItemList.171:6.Name", "Pink Carpet");
	    c.get("ItemList.171:7.MCName", "carpet");
	    c.get("ItemList.171:7.Name", "Gray Carpet");
	    c.get("ItemList.171:8.MCName", "carpet");
	    c.get("ItemList.171:8.Name", "Light Gray Carpet");
	    c.get("ItemList.171:9.MCName", "carpet");
	    c.get("ItemList.171:9.Name", "Cyan Carpet");
	    c.get("ItemList.171:10.MCName", "carpet");
	    c.get("ItemList.171:10.Name", "Purple Carpet");
	    c.get("ItemList.171:11.MCName", "carpet");
	    c.get("ItemList.171:11.Name", "Blue Carpet");
	    c.get("ItemList.171:12.MCName", "carpet");
	    c.get("ItemList.171:12.Name", "Brown Carpet");
	    c.get("ItemList.171:13.MCName", "carpet");
	    c.get("ItemList.171:13.Name", "Green Carpet");
	    c.get("ItemList.171:14.MCName", "carpet");
	    c.get("ItemList.171:14.Name", "Red Carpet");
	    c.get("ItemList.171:15.MCName", "carpet");
	    c.get("ItemList.171:15.Name", "Black Carpet");
	    c.get("ItemList.172.MCName", "hardened_clay");
	    c.get("ItemList.172.Name", "Hardened Clay");
	    c.get("ItemList.173.MCName", "coal_block");
	    c.get("ItemList.173.Name", "Block of Coal");
	    c.get("ItemList.174.MCName", "packed_ice");
	    c.get("ItemList.174.Name", "Packed Ice");
	    c.get("ItemList.175.MCName", "double_plant");
	    c.get("ItemList.175.Name", "All Big Flowers");
	    c.get("ItemList.175:0.MCName", "double_plant");
	    c.get("ItemList.175:0.Name", "Sunflower");
	    c.get("ItemList.175:1.MCName", "double_plant");
	    c.get("ItemList.175:1.Name", "Lilac");
	    c.get("ItemList.175:2.MCName", "double_plant");
	    c.get("ItemList.175:2.Name", "Double Tallgrass");
	    c.get("ItemList.175:3.MCName", "double_plant");
	    c.get("ItemList.175:3.Name", "Large Fern");
	    c.get("ItemList.175:4.MCName", "double_plant");
	    c.get("ItemList.175:4.Name", "Rose Bush");
	    c.get("ItemList.175:5.MCName", "double_plant");
	    c.get("ItemList.175:5.Name", "Peony");
	    c.get("ItemList.176.MCName", "standing_banner");
	    c.get("ItemList.176.Name", "Free-standing Banner");
	    c.get("ItemList.177.MCName", "wall_banner");
	    c.get("ItemList.177.Name", "Wall-mounted Banner");
	    c.get("ItemList.178.MCName", "daylight_detector_inverted");
	    c.get("ItemList.178.Name", "Inverted Daylight Sensor");
	    c.get("ItemList.179.MCName", "red_sandstone");
	    c.get("ItemList.179.Name", "Red Sandstone");
	    c.get("ItemList.179:1.MCName", "red_sandstone");
	    c.get("ItemList.179:1.Name", "Chiseled Red Sandstone");
	    c.get("ItemList.179:2.MCName", "red_sandstone");
	    c.get("ItemList.179:2.Name", "Smooth Red Sandstone");
	    c.get("ItemList.180.MCName", "red_sandstone_stairs");
	    c.get("ItemList.180.Name", "Red Sandstone Stairs");
	    c.get("ItemList.181.MCName", "stone_slab2");
	    c.get("ItemList.181.Name", "Double Red Sandstone Slab");
	    c.get("ItemList.182.MCName", "double_stone_slab2");
	    c.get("ItemList.182.Name", "Red Sandstone Slab");
	    c.get("ItemList.183.MCName", "spruce_fence_gate");
	    c.get("ItemList.183.Name", "Spruce Fence Gate");
	    c.get("ItemList.184.MCName", "birch_fence_gate");
	    c.get("ItemList.184.Name", "Birch Fence Gate");
	    c.get("ItemList.185.MCName", "jungle_fence_gate");
	    c.get("ItemList.185.Name", "Jungle Fence Gate");
	    c.get("ItemList.186.MCName", "dark_oak_fence_gate");
	    c.get("ItemList.186.Name", "Dark Oak Fence Gate");
	    c.get("ItemList.187.MCName", "acacia_fence_gate");
	    c.get("ItemList.187.Name", "Acacia Fence Gate");
	    c.get("ItemList.188.MCName", "spruce_fence");
	    c.get("ItemList.188.Name", "Spruce Fence");
	    c.get("ItemList.189.MCName", "birch_fence");
	    c.get("ItemList.189.Name", "Birch Fence");
	    c.get("ItemList.190.MCName", "jungle_fence");
	    c.get("ItemList.190.Name", "Jungle Fence");
	    c.get("ItemList.191.MCName", "dark_oak_fence");
	    c.get("ItemList.191.Name", "Dark Oak Fence");
	    c.get("ItemList.192.MCName", "acacia_fence");
	    c.get("ItemList.192.Name", "Acacia Fence");
	    c.get("ItemList.193.MCName", "spruce_door");
	    c.get("ItemList.193.Name", "Spure Door Block");
	    c.get("ItemList.194.MCName", "birch_door");
	    c.get("ItemList.194.Name", "Birch Door Block");
	    c.get("ItemList.195.MCName", "jungle_door");
	    c.get("ItemList.195.Name", "Jungle Door Block");
	    c.get("ItemList.196.MCName", "acacia_door");
	    c.get("ItemList.196.Name", "Acacia Door Block");
	    c.get("ItemList.197.MCName", "dark_oak_door");
	    c.get("ItemList.197.Name", "Dark Oak Door Block");
	    c.get("ItemList.198.MCName", "end_rod");
	    c.get("ItemList.198.Name", "End Rod");
	    c.get("ItemList.199.MCName", "chorus_plant");
	    c.get("ItemList.199.Name", "Chorus Plant");
	    c.get("ItemList.200.MCName", "chorus_flower");
	    c.get("ItemList.200.Name", "Chorus Flower");
	    c.get("ItemList.201.MCName", "purpur_block");
	    c.get("ItemList.201.Name", "Purpur Block");
	    c.get("ItemList.202.MCName", "purpur_pillar");
	    c.get("ItemList.202.Name", "Purpur Pillar");
	    c.get("ItemList.203.MCName", "purpur_stairs");
	    c.get("ItemList.203.Name", "Purpur Stairs");
	    c.get("ItemList.204.MCName", "purpur_double_slab");
	    c.get("ItemList.204.Name", "Double Purpur Slab");
	    c.get("ItemList.205.MCName", "purpur_slab");
	    c.get("ItemList.205.Name", "Purpur Slab");
	    c.get("ItemList.206.MCName", "end_bricks");
	    c.get("ItemList.206.Name", "End Stone Bricks");
	    c.get("ItemList.207.MCName", "beetroots");
	    c.get("ItemList.207.Name", "Beetroot Block");
	    c.get("ItemList.208.MCName", "grass_path");
	    c.get("ItemList.208.Name", "Grass Path");
	    c.get("ItemList.209.MCName", "end_gateway");
	    c.get("ItemList.209.Name", "End Gateway Block");
	    c.get("ItemList.212.MCName", "frosted_ice");
	    c.get("ItemList.212.Name", "Frosted Ice");
	    c.get("ItemList.256.MCName", "iron_shovel");
	    c.get("ItemList.256.Name", "Iron Shovel");
	    c.get("ItemList.257.MCName", "iron_pickaxe");
	    c.get("ItemList.257.Name", "Iron Pickaxe");
	    c.get("ItemList.258.MCName", "iron_axe");
	    c.get("ItemList.258.Name", "Iron Axe");
	    c.get("ItemList.259.MCName", "flint_and_steel");
	    c.get("ItemList.259.Name", "Flint and Steel");
	    c.get("ItemList.260.MCName", "apple");
	    c.get("ItemList.260.Name", "Apple");
	    c.get("ItemList.261.MCName", "bow");
	    c.get("ItemList.261.Name", "Bow");
	    c.get("ItemList.262.MCName", "arrow");
	    c.get("ItemList.262.Name", "Arrow");
	    c.get("ItemList.263.MCName", "coal");
	    c.get("ItemList.263.Name", "Coal");
	    c.get("ItemList.263:1.MCName", "coal");
	    c.get("ItemList.263:1.Name", "Charcoal");
	    c.get("ItemList.264.MCName", "diamond");
	    c.get("ItemList.264.Name", "Diamond");
	    c.get("ItemList.265.MCName", "iron_ingot");
	    c.get("ItemList.265.Name", "Iron Ingot");
	    c.get("ItemList.266.MCName", "gold_ingot");
	    c.get("ItemList.266.Name", "Gold Ingot");
	    c.get("ItemList.267.MCName", "iron_sword");
	    c.get("ItemList.267.Name", "Iron Sword");
	    c.get("ItemList.268.MCName", "wooden_sword");
	    c.get("ItemList.268.Name", "Wooden Sword");
	    c.get("ItemList.269.MCName", "wooden_shovel");
	    c.get("ItemList.269.Name", "Wooden Shovel");
	    c.get("ItemList.270.MCName", "wooden_pickaxe");
	    c.get("ItemList.270.Name", "Wooden Pickaxe");
	    c.get("ItemList.271.MCName", "wooden_axe");
	    c.get("ItemList.271.Name", "Wooden Axe");
	    c.get("ItemList.272.MCName", "stone_sword");
	    c.get("ItemList.272.Name", "Stone Sword");
	    c.get("ItemList.273.MCName", "stone_shovel");
	    c.get("ItemList.273.Name", "Stone Shovel");
	    c.get("ItemList.274.MCName", "stone_pickaxe");
	    c.get("ItemList.274.Name", "Stone Pickaxe");
	    c.get("ItemList.275.MCName", "stone_axe");
	    c.get("ItemList.275.Name", "Stone Axe");
	    c.get("ItemList.276.MCName", "diamond_sword");
	    c.get("ItemList.276.Name", "Diamond Sword");
	    c.get("ItemList.277.MCName", "diamond_shovel");
	    c.get("ItemList.277.Name", "Diamond Shovel");
	    c.get("ItemList.278.MCName", "diamond_pickaxe");
	    c.get("ItemList.278.Name", "Diamond Pickaxe");
	    c.get("ItemList.279.MCName", "diamond_axe");
	    c.get("ItemList.279.Name", "Diamond Axe");
	    c.get("ItemList.280.MCName", "stick");
	    c.get("ItemList.280.Name", "Stick");
	    c.get("ItemList.281.MCName", "bowl");
	    c.get("ItemList.281.Name", "Bowl");
	    c.get("ItemList.282.MCName", "mushroom_stew");
	    c.get("ItemList.282.Name", "Mushroom Stew");
	    c.get("ItemList.283.MCName", "golden_sword");
	    c.get("ItemList.283.Name", "Golden Sword");
	    c.get("ItemList.284.MCName", "golden_shovel");
	    c.get("ItemList.284.Name", "Golden Shovel");
	    c.get("ItemList.285.MCName", "golden_pickaxe");
	    c.get("ItemList.285.Name", "Golden Pickaxe");
	    c.get("ItemList.286.MCName", "golden_axe");
	    c.get("ItemList.286.Name", "Golden Axe");
	    c.get("ItemList.287.MCName", "string");
	    c.get("ItemList.287.Name", "String");
	    c.get("ItemList.288.MCName", "feather");
	    c.get("ItemList.288.Name", "Feather");
	    c.get("ItemList.289.MCName", "gunpowder");
	    c.get("ItemList.289.Name", "Gunpowder");
	    c.get("ItemList.290.MCName", "wooden_hoe");
	    c.get("ItemList.290.Name", "Wooden Hoe");
	    c.get("ItemList.291.MCName", "stone_hoe");
	    c.get("ItemList.291.Name", "Stone Hoe");
	    c.get("ItemList.292.MCName", "iron_hoe");
	    c.get("ItemList.292.Name", "Iron Hoe");
	    c.get("ItemList.293.MCName", "diamond_hoe");
	    c.get("ItemList.293.Name", "Diamond Hoe");
	    c.get("ItemList.294.MCName", "golden_hoe");
	    c.get("ItemList.294.Name", "Golden Hoe");
	    c.get("ItemList.295.MCName", "wheat_seeds");
	    c.get("ItemList.295.Name", "Wheat Seeds");
	    c.get("ItemList.296.MCName", "wheat");
	    c.get("ItemList.296.Name", "Wheat");
	    c.get("ItemList.297.MCName", "bread");
	    c.get("ItemList.297.Name", "Bread");
	    c.get("ItemList.298.MCName", "leather_helmet");
	    c.get("ItemList.298.Name", "Leather Helmet");
	    c.get("ItemList.299.MCName", "leather_chestplate");
	    c.get("ItemList.299.Name", "Leather Tunic");
	    c.get("ItemList.300.MCName", "leather_leggings");
	    c.get("ItemList.300.Name", "Leather Pants");
	    c.get("ItemList.301.MCName", "leather_boots");
	    c.get("ItemList.301.Name", "Leather Boots");
	    c.get("ItemList.302.MCName", "chainmail_helmet");
	    c.get("ItemList.302.Name", "Chainmail Helmet");
	    c.get("ItemList.303.MCName", "chainmail_chestplate");
	    c.get("ItemList.303.Name", "Chainmail Chestplate");
	    c.get("ItemList.304.MCName", "chainmail_leggings");
	    c.get("ItemList.304.Name", "Chainmail Leggings");
	    c.get("ItemList.305.MCName", "chainmail_boots");
	    c.get("ItemList.305.Name", "Chainmail Boots");
	    c.get("ItemList.306.MCName", "iron_helmet");
	    c.get("ItemList.306.Name", "Iron Helmet");
	    c.get("ItemList.307.MCName", "iron_chestplate");
	    c.get("ItemList.307.Name", "Iron Chestplate");
	    c.get("ItemList.308.MCName", "iron_leggings");
	    c.get("ItemList.308.Name", "Iron Leggings");
	    c.get("ItemList.309.MCName", "iron_boots");
	    c.get("ItemList.309.Name", "Iron Boots");
	    c.get("ItemList.310.MCName", "diamond_helmet");
	    c.get("ItemList.310.Name", "Diamond Helmet");
	    c.get("ItemList.311.MCName", "diamond_chestplate");
	    c.get("ItemList.311.Name", "Diamond Chestplate");
	    c.get("ItemList.312.MCName", "diamond_leggings");
	    c.get("ItemList.312.Name", "Diamond Leggings");
	    c.get("ItemList.313.MCName", "diamond_boots");
	    c.get("ItemList.313.Name", "Diamond Boots");
	    c.get("ItemList.314.MCName", "golden_helmet");
	    c.get("ItemList.314.Name", "Golden Helmet");
	    c.get("ItemList.315.MCName", "golden_chestplate");
	    c.get("ItemList.315.Name", "Golden Chestplate");
	    c.get("ItemList.316.MCName", "golden_leggings");
	    c.get("ItemList.316.Name", "Golden Leggings");
	    c.get("ItemList.317.MCName", "golden_boots");
	    c.get("ItemList.317.Name", "Golden Boots");
	    c.get("ItemList.318.MCName", "flint_and_steel");
	    c.get("ItemList.318.Name", "Flint");
	    c.get("ItemList.319.MCName", "porkchop");
	    c.get("ItemList.319.Name", "Raw Porkchop");
	    c.get("ItemList.320.MCName", "cooked_porkchop");
	    c.get("ItemList.320.Name", "Cooked Porkchop");
	    c.get("ItemList.321.MCName", "painting");
	    c.get("ItemList.321.Name", "Painting");
	    c.get("ItemList.322.MCName", "golden_apple");
	    c.get("ItemList.322.Name", "Golden Apple");
	    c.get("ItemList.322:1.MCName", "golden_apple");
	    c.get("ItemList.322:1.Name", "Enchanted Golden Apple");
	    c.get("ItemList.323.MCName", "sign");
	    c.get("ItemList.323.Name", "Sign");
	    c.get("ItemList.324.MCName", "wooden_door");
	    c.get("ItemList.324.Name", "Wooden Door");
	    c.get("ItemList.325.MCName", "bucket");
	    c.get("ItemList.325.Name", "Bucket");
	    c.get("ItemList.326.MCName", "water_bucket");
	    c.get("ItemList.326.Name", "Water Bucket");
	    c.get("ItemList.327.MCName", "lava_bucket");
	    c.get("ItemList.327.Name", "Lava Bucket");
	    c.get("ItemList.328.MCName", "minecart");
	    c.get("ItemList.328.Name", "Minecart");
	    c.get("ItemList.329.MCName", "saddle");
	    c.get("ItemList.329.Name", "Saddle");
	    c.get("ItemList.330.MCName", "iron_door");
	    c.get("ItemList.330.Name", "Iron Door");
	    c.get("ItemList.331.MCName", "redstone");
	    c.get("ItemList.331.Name", "Redstone");
	    c.get("ItemList.332.MCName", "snowball");
	    c.get("ItemList.332.Name", "Snowball");
	    c.get("ItemList.333.MCName", "boat");
	    c.get("ItemList.333.Name", "Boat");
	    c.get("ItemList.334.MCName", "leather");
	    c.get("ItemList.334.Name", "Leather");
	    c.get("ItemList.335.MCName", "milk_bucket");
	    c.get("ItemList.335.Name", "Milk Bucket");
	    c.get("ItemList.336.MCName", "brick");
	    c.get("ItemList.336.Name", "Brick");
	    c.get("ItemList.337.MCName", "clay_ball");
	    c.get("ItemList.337.Name", "Clay Ball");
	    c.get("ItemList.338.MCName", "reeds");
	    c.get("ItemList.338.Name", "Sugar Canes");
	    c.get("ItemList.339.MCName", "paper");
	    c.get("ItemList.339.Name", "Paper");
	    c.get("ItemList.340.MCName", "book");
	    c.get("ItemList.340.Name", "Book");
	    c.get("ItemList.341.MCName", "slime_ball");
	    c.get("ItemList.341.Name", "Slimeball");
	    c.get("ItemList.342.MCName", "chest_minecart");
	    c.get("ItemList.342.Name", "Minecart with Chest");
	    c.get("ItemList.343.MCName", "furnace_minecart");
	    c.get("ItemList.343.Name", "Minecart with Furnace");
	    c.get("ItemList.344.MCName", "egg");
	    c.get("ItemList.344.Name", "Egg");
	    c.get("ItemList.345.MCName", "compass");
	    c.get("ItemList.345.Name", "Compass");
	    c.get("ItemList.346.MCName", "fishing_rod");
	    c.get("ItemList.346.Name", "Fishing Rod");
	    c.get("ItemList.347.MCName", "clock");
	    c.get("ItemList.347.Name", "Clock");
	    c.get("ItemList.348.MCName", "glowstone_dust");
	    c.get("ItemList.348.Name", "Glowstone Dust");
	    c.get("ItemList.349.MCName", "fish");
	    c.get("ItemList.349.Name", "Raw Fish");
	    c.get("ItemList.349:1.MCName", "fish");
	    c.get("ItemList.349:1.Name", "Raw Salmon");
	    c.get("ItemList.349:2.MCName", "fish");
	    c.get("ItemList.349:2.Name", "Clownfish");
	    c.get("ItemList.349:3.MCName", "fish");
	    c.get("ItemList.349:3.Name", "Pufferfish");
	    c.get("ItemList.350.MCName", "cooked_fish");
	    c.get("ItemList.350.Name", "Cooked Fish");
	    c.get("ItemList.350:1.MCName", "cooked_fish");
	    c.get("ItemList.350:1.Name", "Cooked Salmon");
	    c.get("ItemList.351.MCName", "dye");
	    c.get("ItemList.351.Name", "All Dyes");
	    c.get("ItemList.351:0.MCName", "dye");
	    c.get("ItemList.351:0.Name", "Ink Sack");
	    c.get("ItemList.351:1.MCName", "dye");
	    c.get("ItemList.351:1.Name", "Rose Red");
	    c.get("ItemList.351:2.MCName", "dye");
	    c.get("ItemList.351:2.Name", "Cactus Green");
	    c.get("ItemList.351:3.MCName", "dye");
	    c.get("ItemList.351:3.Name", "Coco Beans");
	    c.get("ItemList.351:4.MCName", "dye");
	    c.get("ItemList.351:4.Name", "Lapis Lazuli");
	    c.get("ItemList.351:5.MCName", "dye");
	    c.get("ItemList.351:5.Name", "Purple Dye");
	    c.get("ItemList.351:6.MCName", "dye");
	    c.get("ItemList.351:6.Name", "Cyan Dye");
	    c.get("ItemList.351:7.MCName", "dye");
	    c.get("ItemList.351:7.Name", "Light Gray Dye");
	    c.get("ItemList.351:8.MCName", "dye");
	    c.get("ItemList.351:8.Name", "Gray Dye");
	    c.get("ItemList.351:9.MCName", "dye");
	    c.get("ItemList.351:9.Name", "Pink Dye");
	    c.get("ItemList.351:10.MCName", "dye");
	    c.get("ItemList.351:10.Name", "Lime Dye");
	    c.get("ItemList.351:11.MCName", "dye");
	    c.get("ItemList.351:11.Name", "Dandelion Yellow");
	    c.get("ItemList.351:12.MCName", "dye");
	    c.get("ItemList.351:12.Name", "Light Blue Dye");
	    c.get("ItemList.351:13.MCName", "dye");
	    c.get("ItemList.351:13.Name", "Magenta Dye");
	    c.get("ItemList.351:14.MCName", "dye");
	    c.get("ItemList.351:14.Name", "Orange Dye");
	    c.get("ItemList.351:15.MCName", "dye");
	    c.get("ItemList.351:15.Name", "Bone Meal");
	    c.get("ItemList.352.MCName", "bone");
	    c.get("ItemList.352.Name", "Bone");
	    c.get("ItemList.353.MCName", "sugar");
	    c.get("ItemList.353.Name", "Sugar");
	    c.get("ItemList.354.MCName", "cake");
	    c.get("ItemList.354.Name", "Cake");
	    c.get("ItemList.355.MCName", "bed");
	    c.get("ItemList.355.Name", "Bed");
	    c.get("ItemList.356.MCName", "repeater");
	    c.get("ItemList.356.Name", "Redstone Repeater");
	    c.get("ItemList.357.MCName", "cookie");
	    c.get("ItemList.357.Name", "Cookie");
	    c.get("ItemList.358.MCName", "filled_map");
	    c.get("ItemList.358.Name", "Map");
	    c.get("ItemList.359.MCName", "shears");
	    c.get("ItemList.359.Name", "Shears");
	    c.get("ItemList.360.MCName", "melon");
	    c.get("ItemList.360.Name", "Melon");
	    c.get("ItemList.361.MCName", "pumpkin_seeds");
	    c.get("ItemList.361.Name", "Pumpkin Seeds");
	    c.get("ItemList.362.MCName", "melon_seeds");
	    c.get("ItemList.362.Name", "Melon Seeds");
	    c.get("ItemList.363.MCName", "beef");
	    c.get("ItemList.363.Name", "Raw Beef");
	    c.get("ItemList.364.MCName", "cooked_beef");
	    c.get("ItemList.364.Name", "Steak");
	    c.get("ItemList.365.MCName", "chicken");
	    c.get("ItemList.365.Name", "Raw Chicken");
	    c.get("ItemList.366.MCName", "cooked_chicken");
	    c.get("ItemList.366.Name", "Cooked Chicken");
	    c.get("ItemList.367.MCName", "rotten_flesh");
	    c.get("ItemList.367.Name", "Rotten Flesh");
	    c.get("ItemList.368.MCName", "ender_pearl");
	    c.get("ItemList.368.Name", "Ender Pearl");
	    c.get("ItemList.369.MCName", "blaze_rod");
	    c.get("ItemList.369.Name", "Blaze Rod");
	    c.get("ItemList.370.MCName", "ghast_tear");
	    c.get("ItemList.370.Name", "Ghast Tear");
	    c.get("ItemList.371.MCName", "gold_nugget");
	    c.get("ItemList.371.Name", "Gold Nugget");
	    c.get("ItemList.372.MCName", "nether_wart");
	    c.get("ItemList.372.Name", "Nether Wart");
	    c.get("ItemList.373.MCName", "potion");
	    c.get("ItemList.373.Name", "Potion");
	    c.get("ItemList.374.MCName", "glass_bottle");
	    c.get("ItemList.374.Name", "Glass Bottle");
	    c.get("ItemList.375.MCName", "spider_eye");
	    c.get("ItemList.375.Name", "Spider Eye");
	    c.get("ItemList.376.MCName", "fermented_spider_eye");
	    c.get("ItemList.376.Name", "Fermented Spider Eye");
	    c.get("ItemList.377.MCName", "blaze_powder");
	    c.get("ItemList.377.Name", "Blaze Powder");
	    c.get("ItemList.378.MCName", "magma_cream");
	    c.get("ItemList.378.Name", "Magma Cream");
	    c.get("ItemList.379.MCName", "brewing_stand");
	    c.get("ItemList.379.Name", "Brewing Stand");
	    c.get("ItemList.380.MCName", "cauldron");
	    c.get("ItemList.380.Name", "Cauldron");
	    c.get("ItemList.381.MCName", "ender_eye");
	    c.get("ItemList.381.Name", "Eye of Ender");
	    c.get("ItemList.382.MCName", "speckled_melon");
	    c.get("ItemList.382.Name", "Glistering Melon");
	    c.get("ItemList.383:50.MCName", "spawn_egg");
	    c.get("ItemList.383:50.Name", "Spawn Creeper");
	    c.get("ItemList.383:51.MCName", "spawn_egg");
	    c.get("ItemList.383:51.Name", "Spawn Skeleton");
	    c.get("ItemList.383:52.MCName", "spawn_egg");
	    c.get("ItemList.383:52.Name", "Spawn Spider");
	    c.get("ItemList.383:54.MCName", "spawn_egg");
	    c.get("ItemList.383:54.Name", "Spawn Zombie");
	    c.get("ItemList.383:55.MCName", "spawn_egg");
	    c.get("ItemList.383:55.Name", "Spawn Slime");
	    c.get("ItemList.383:56.MCName", "spawn_egg");
	    c.get("ItemList.383:56.Name", "Spawn Ghast");
	    c.get("ItemList.383:57.MCName", "spawn_egg");
	    c.get("ItemList.383:57.Name", "Spawn Pigman");
	    c.get("ItemList.383:58.MCName", "spawn_egg");
	    c.get("ItemList.383:58.Name", "Spawn Enderman");
	    c.get("ItemList.383:59.MCName", "spawn_egg");
	    c.get("ItemList.383:59.Name", "Spawn Cave Spider");
	    c.get("ItemList.383:60.MCName", "spawn_egg");
	    c.get("ItemList.383:60.Name", "Spawn Silverfish");
	    c.get("ItemList.383:61.MCName", "spawn_egg");
	    c.get("ItemList.383:61.Name", "Spawn Blaze");
	    c.get("ItemList.383:62.MCName", "spawn_egg");
	    c.get("ItemList.383:62.Name", "Spawn Magma Cube");
	    c.get("ItemList.383:65.MCName", "spawn_egg");
	    c.get("ItemList.383:65.Name", "Spawn Bat");
	    c.get("ItemList.383:66.MCName", "spawn_egg");
	    c.get("ItemList.383:66.Name", "Spawn Witch");
	    c.get("ItemList.383:67.MCName", "spawn_egg");
	    c.get("ItemList.383:67.Name", "Spawn Endermite");
	    c.get("ItemList.383:68.MCName", "spawn_egg");
	    c.get("ItemList.383:68.Name", "Spawn Guardian");
	    c.get("ItemList.383:90.MCName", "spawn_egg");
	    c.get("ItemList.383:90.Name", "Spawn Pig");
	    c.get("ItemList.383:91.MCName", "spawn_egg");
	    c.get("ItemList.383:91.Name", "Spawn Sheep");
	    c.get("ItemList.383:92.MCName", "spawn_egg");
	    c.get("ItemList.383:92.Name", "Spawn Cow");
	    c.get("ItemList.383:93.MCName", "spawn_egg");
	    c.get("ItemList.383:93.Name", "Spawn Chicken");
	    c.get("ItemList.383:94.MCName", "spawn_egg");
	    c.get("ItemList.383:94.Name", "Spawn Squid");
	    c.get("ItemList.383:95.MCName", "spawn_egg");
	    c.get("ItemList.383:95.Name", "Spawn Wolf");
	    c.get("ItemList.383:96.MCName", "spawn_egg");
	    c.get("ItemList.383:96.Name", "Spawn Mooshroom");
	    c.get("ItemList.383:98.MCName", "spawn_egg");
	    c.get("ItemList.383:98.Name", "Spawn Ocelot");
	    c.get("ItemList.383:100.MCName", "spawn_egg");
	    c.get("ItemList.383:100.Name", "Spawn Horse");
	    c.get("ItemList.383:101.MCName", "spawn_egg");
	    c.get("ItemList.383:101.Name", "Spawn Rabbit");
	    c.get("ItemList.383:120.MCName", "spawn_egg");
	    c.get("ItemList.383:120.Name", "Spawn Villager");
	    c.get("ItemList.384.MCName", "experience_bottle");
	    c.get("ItemList.384.Name", "Bottle o' Enchanting");
	    c.get("ItemList.385.MCName", "fire_charge");
	    c.get("ItemList.385.Name", "Fire Charge");
	    c.get("ItemList.386.MCName", "writable_book");
	    c.get("ItemList.386.Name", "Book and Quill");
	    c.get("ItemList.387.MCName", "written_book");
	    c.get("ItemList.387.Name", "Written Book");
	    c.get("ItemList.388.MCName", "emerald");
	    c.get("ItemList.388.Name", "Emerald");
	    c.get("ItemList.389.MCName", "item_frame");
	    c.get("ItemList.389.Name", "Item Frame");
	    c.get("ItemList.390.MCName", "flower_pot");
	    c.get("ItemList.390.Name", "Flower Pot");
	    c.get("ItemList.391.MCName", "carrot");
	    c.get("ItemList.391.Name", "Carrot");
	    c.get("ItemList.392.MCName", "potato");
	    c.get("ItemList.392.Name", "Potato");
	    c.get("ItemList.393.MCName", "baked_potato");
	    c.get("ItemList.393.Name", "Baked Potato");
	    c.get("ItemList.394.MCName", "poisonous_potato");
	    c.get("ItemList.394.Name", "Poisonous Potato");
	    c.get("ItemList.395.MCName", "map");
	    c.get("ItemList.395.Name", "Empty Map");
	    c.get("ItemList.396.MCName", "golden_carrot");
	    c.get("ItemList.396.Name", "Golden Carrot");
	    c.get("ItemList.397.MCName", "skull");
	    c.get("ItemList.397.Name", "Mob Head (Skeleton)");
	    c.get("ItemList.397:1.MCName", "skull");
	    c.get("ItemList.397:1.Name", "Mob Head (Wither Skeleton)");
	    c.get("ItemList.397:2.MCName", "skull");
	    c.get("ItemList.397:2.Name", "Mob Head (Zombie)");
	    c.get("ItemList.397:3.MCName", "skull");
	    c.get("ItemList.397:3.Name", "Mob Head (Human)");
	    c.get("ItemList.397:4.MCName", "skull");
	    c.get("ItemList.397:4.Name", "Mob Head (Creeper)");
	    c.get("ItemList.398.MCName", "carrot_on_a_stick");
	    c.get("ItemList.398.Name", "Carrot on a Stick");
	    c.get("ItemList.399.MCName", "nether_star");
	    c.get("ItemList.399.Name", "Nether Star");
	    c.get("ItemList.400.MCName", "pumpkin_pie");
	    c.get("ItemList.400.Name", "Pumpkin Pie");
	    c.get("ItemList.401.MCName", "fireworks");
	    c.get("ItemList.401.Name", "Firework Rocket");
	    c.get("ItemList.402.MCName", "firework_charge");
	    c.get("ItemList.402.Name", "Firework Star");
	    c.get("ItemList.403.MCName", "enchanted_book");
	    c.get("ItemList.403.Name", "Enchanted Book");
	    c.get("ItemList.404.MCName", "comparator");
	    c.get("ItemList.404.Name", "Redstone Comparator");
	    c.get("ItemList.405.MCName", "netherbrick");
	    c.get("ItemList.405.Name", "Nether Brick");
	    c.get("ItemList.406.MCName", "quartz");
	    c.get("ItemList.406.Name", "Nether Quartz");
	    c.get("ItemList.407.MCName", "tnt_minecart");
	    c.get("ItemList.407.Name", "Minecart with TNT");
	    c.get("ItemList.408.MCName", "hopper_minecart");
	    c.get("ItemList.408.Name", "Minecart with Hopper");
	    c.get("ItemList.409.MCName", "prismarine_shard");
	    c.get("ItemList.409.Name", "Prismarine Shard");
	    c.get("ItemList.410.MCName", "prismarine_crystals");
	    c.get("ItemList.410.Name", "Prismarine Crystals");
	    c.get("ItemList.411.MCName", "rabbit");
	    c.get("ItemList.411.Name", "Raw Rabbit");
	    c.get("ItemList.412.MCName", "cooked_rabbit");
	    c.get("ItemList.412.Name", "Cooked Rabbit");
	    c.get("ItemList.413.MCName", "rabbit_stew");
	    c.get("ItemList.413.Name", "Rabbit Stew");
	    c.get("ItemList.414.MCName", "rabbit_foot");
	    c.get("ItemList.414.Name", "Rabbit's Foot");
	    c.get("ItemList.415.MCName", "rabbit_hide");
	    c.get("ItemList.415.Name", "Rabbit Hide");
	    c.get("ItemList.416.MCName", "armor_stand");
	    c.get("ItemList.416.Name", "Armor Stand");
	    c.get("ItemList.417.MCName", "iron_horse_armor");
	    c.get("ItemList.417.Name", "Iron Horse Armor");
	    c.get("ItemList.418.MCName", "golden_horse_armor");
	    c.get("ItemList.418.Name", "Golden Horse Armor");
	    c.get("ItemList.419.MCName", "diamond_horse_armor");
	    c.get("ItemList.419.Name", "Diamond Horse Armor");
	    c.get("ItemList.420.MCName", "lead");
	    c.get("ItemList.420.Name", "Lead");
	    c.get("ItemList.421.MCName", "name_tag");
	    c.get("ItemList.421.Name", "Name Tag");
	    c.get("ItemList.422.MCName", "command_block_minecart");
	    c.get("ItemList.422.Name", "Minecart with Command Block");
	    c.get("ItemList.423.MCName", "mutton");
	    c.get("ItemList.423.Name", "Raw Mutton");
	    c.get("ItemList.424.MCName", "cooked_mutton");
	    c.get("ItemList.424.Name", "Cooked Mutton");
	    c.get("ItemList.425.MCName", "banner");
	    c.get("ItemList.425.Name", "Banner");
	    c.get("ItemList.426.MCName", "end_crystal");
	    c.get("ItemList.426.Name", "End Crystal");
	    c.get("ItemList.427.MCName", "spruce_door");
	    c.get("ItemList.427.Name", "Spruce Door");
	    c.get("ItemList.428.MCName", "birch_door");
	    c.get("ItemList.428.Name", "Birch Door");
	    c.get("ItemList.429.MCName", "jungle_door");
	    c.get("ItemList.429.Name", "Jungle Door");
	    c.get("ItemList.430.MCName", "acacia_door");
	    c.get("ItemList.430.Name", "Acacia Door");
	    c.get("ItemList.431.MCName", "dark_oak_door");
	    c.get("ItemList.431.Name", "Dark Oak Door");
	    c.get("ItemList.432.MCName", "chorus_fruit");
	    c.get("ItemList.432.Name", "Chorus Fruit");
	    c.get("ItemList.433.MCName", "chorus_fruit_popped");
	    c.get("ItemList.433.Name", "Popped Chorus Fruit");
	    c.get("ItemList.434.MCName", "beetroot");
	    c.get("ItemList.434.Name", "Beetroot");
	    c.get("ItemList.435.MCName", "beetroot_seeds");
	    c.get("ItemList.435.Name", "Beetroot Seeds");
	    c.get("ItemList.436.MCName", "beetroot_soup");
	    c.get("ItemList.436.Name", "Beetroot Soup");
	    c.get("ItemList.437.MCName", "dragon_breath");
	    c.get("ItemList.437.Name", "Dragon's Breath");
	    c.get("ItemList.439.MCName", "spectral_arrow");
	    c.get("ItemList.439.Name", "Spectral Arrow");
	    c.get("ItemList.440.MCName", "tipped_arrow");
	    c.get("ItemList.440.Name", "Tipped Arrow");
	    c.get("ItemList.441.MCName", "lingering_potion");
	    c.get("ItemList.441.Name", "Lingering Potion");
	    c.get("ItemList.442.MCName", "shield");
	    c.get("ItemList.442.Name", "Shield");
	    c.get("ItemList.443.MCName", "elytra");
	    c.get("ItemList.443.Name", "Elytra");
	    c.get("ItemList.2256.MCName", "record_13");
	    c.get("ItemList.2256.Name", "13 Disc");
	    c.get("ItemList.2257.MCName", "record_cat");
	    c.get("ItemList.2257.Name", "Cat Disc");
	    c.get("ItemList.2258.MCName", "record_blocks");
	    c.get("ItemList.2258.Name", "Blocks Disc");
	    c.get("ItemList.2259.MCName", "record_chirp");
	    c.get("ItemList.2259.Name", "Chirp Disc");
	    c.get("ItemList.2260.MCName", "record_far");
	    c.get("ItemList.2260.Name", "Far Disc");
	    c.get("ItemList.2261.MCName", "record_mall");
	    c.get("ItemList.2261.Name", "Mall Disc");
	    c.get("ItemList.2262.MCName", "record_mellohi");
	    c.get("ItemList.2262.Name", "Mellohi Disc");
	    c.get("ItemList.2263.MCName", "record_stal");
	    c.get("ItemList.2263.Name", "Stal Disc");
	    c.get("ItemList.2264.MCName", "record_strad");
	    c.get("ItemList.2264.Name", "Strad Disc");
	    c.get("ItemList.2265.MCName", "record_ward");
	    c.get("ItemList.2265.Name", "Ward Disc");
	    c.get("ItemList.2266.MCName", "record_11");
	    c.get("ItemList.2266.Name", "11 Disc");
	    c.get("ItemList.2267.MCName", "record_wait");
	    c.get("ItemList.2267.Name", "Wait Disc");

	    // Entity list
	    c.get("EntityList.-1.MCName", "Player");
	    c.get("EntityList.-1.Name", "Player");
	    c.get("EntityList.50.MCName", "Creeper");
	    c.get("EntityList.50.Name", "Creeper");
	    c.get("EntityList.51.MCName", "Skeleton");
	    c.get("EntityList.51.Name", "Skeleton");
	    c.get("EntityList.51:1.MCName", "Skeleton");
	    c.get("EntityList.51:1.Name", "WitherSkeleton");
	    c.get("EntityList.51:2.MCName", "Skeleton");
	    c.get("EntityList.51:2.Name", "Skeleton Stray");
	    c.get("EntityList.52.MCName", "Spider");
	    c.get("EntityList.52.Name", "Spider");
	    c.get("EntityList.53.MCName", "Giant");
	    c.get("EntityList.53.Name", "Giant");
	    c.get("EntityList.54.MCName", "Zombie");
	    c.get("EntityList.54.Name", "Zombie");
	    c.get("EntityList.54:1.MCName", "Zombie");
	    c.get("EntityList.54:1.Name", "Zombie Villager");
	    c.get("EntityList.54:2.MCName", "Zombie");
	    c.get("EntityList.54:2.Name", "Zombie Husk");
	    c.get("EntityList.55.MCName", "Slime");
	    c.get("EntityList.55.Name", "Slime");
	    c.get("EntityList.56.MCName", "Ghast");
	    c.get("EntityList.56.Name", "Ghast");
	    c.get("EntityList.57.MCName", "PigZombie");
	    c.get("EntityList.57.Name", "Zombie Pigman");
	    c.get("EntityList.58.MCName", "Enderman");
	    c.get("EntityList.58.Name", "Enderman");
	    c.get("EntityList.59.MCName", "CaveSpider");
	    c.get("EntityList.59.Name", "Cave Spider");
	    c.get("EntityList.60.MCName", "Silverfish");
	    c.get("EntityList.60.Name", "Silverfish");
	    c.get("EntityList.61.MCName", "Blaze");
	    c.get("EntityList.61.Name", "Blaze");
	    c.get("EntityList.62.MCName", "LavaSlime");
	    c.get("EntityList.62.Name", "LavaSlime");
	    c.get("EntityList.63.MCName", "EnderDragon");
	    c.get("EntityList.63.Name", "EnderDragon");
	    c.get("EntityList.64.MCName", "WitherBoss");
	    c.get("EntityList.64.Name", "Wither");
	    c.get("EntityList.65.MCName", "Bat");
	    c.get("EntityList.65.Name", "Bat");
	    c.get("EntityList.66.MCName", "Witch");
	    c.get("EntityList.66.Name", "Witch");
	    c.get("EntityList.67.MCName", "Endermite");
	    c.get("EntityList.67.Name", "Endermite");
	    c.get("EntityList.68.MCName", "Guardian");
	    c.get("EntityList.68.Name", "Guardian");
	    c.get("EntityList.68:1.MCName", "Guardian");
	    c.get("EntityList.68:1.Name", "Elder Guardian");
	    c.get("EntityList.69.MCName", "Shulker");
	    c.get("EntityList.69.Name", "Shulker");
	    c.get("EntityList.90.MCName", "Pig");
	    c.get("EntityList.90.Name", "Pig");
	    c.get("EntityList.91.MCName", "Sheep");
	    c.get("EntityList.91.Name", "Sheep");
	    c.get("EntityList.92.MCName", "Cow");
	    c.get("EntityList.92.Name", "Cow");
	    c.get("EntityList.93.MCName", "Chicken");
	    c.get("EntityList.93.Name", "Chicken");
	    c.get("EntityList.94.MCName", "Squid");
	    c.get("EntityList.94.Name", "Squid");
	    c.get("EntityList.95.MCName", "Wolf");
	    c.get("EntityList.95.Name", "Wolf");
	    c.get("EntityList.96.MCName", "MushroomCow");
	    c.get("EntityList.96.Name", "MushroomCow");
	    c.get("EntityList.97.MCName", "SnowMan");
	    c.get("EntityList.97.Name", "Snow Golem");
	    c.get("EntityList.98.MCName", "Ozelot");
	    c.get("EntityList.98.Name", "Ocelot");
	    c.get("EntityList.99.MCName", "VillagerGolem");
	    c.get("EntityList.99.Name", "Iron Golem");
	    c.get("EntityList.100.MCName", "EntityHorse");
	    c.get("EntityList.100.Name", "Horse");
	    c.get("EntityList.101.MCName", "Rabbit");
	    c.get("EntityList.101.Name", "Rabbit");
	    c.get("EntityList.102.MCName", "PolarBear");
	    c.get("EntityList.102.Name", "Polar Bear");
	    c.get("EntityList.120.MCName", "Villager");
	    c.get("EntityList.120.Name", "Villager");
	    c.get("EntityList.200.MCName", "EnderCrystal");
	    c.get("EntityList.200.Name", "Ender Crystal");

	    // Enchant list
	    c.get("EnchantList.0.MCName", "PROTECTION_ENVIRONMENTAL");
	    c.get("EnchantList.0.Name", "Protection");
	    c.get("EnchantList.1.MCName", "PROTECTION_FIRE");
	    c.get("EnchantList.1.Name", "Fire Protection");
	    c.get("EnchantList.2.MCName", "PROTECTION_FALL");
	    c.get("EnchantList.2.Name", "Feather Falling");
	    c.get("EnchantList.3.MCName", "PROTECTION_EXPLOSIONS");
	    c.get("EnchantList.3.Name", "Blast Protection");
	    c.get("EnchantList.4.MCName", "ROTECTION_PROJECTILE");
	    c.get("EnchantList.4.Name", "Projectile Protection");
	    c.get("EnchantList.5.MCName", "OXYGEN");
	    c.get("EnchantList.5.Name", "Respiration");
	    c.get("EnchantList.6.MCName", "DIG_SPEED");
	    c.get("EnchantList.6.Name", "Aqua Affinity");
	    c.get("EnchantList.7.MCName", "THORNS");
	    c.get("EnchantList.7.Name", "Thorns");
	    c.get("EnchantList.8.MCName", "DEPTH_STRIDER");
	    c.get("EnchantList.8.Name", "Depth Strider");
	    c.get("EnchantList.9.MCName", "FROST_WALKER");
	    c.get("EnchantList.9.Name", "Frost Walker");
	    c.get("EnchantList.16.MCName", "DAMAGE_ALL");
	    c.get("EnchantList.16.Name", "Sharpness");
	    c.get("EnchantList.17.MCName", "DAMAGE_UNDEAD");
	    c.get("EnchantList.17.Name", "Smite");
	    c.get("EnchantList.18.MCName", "DAMAGE_ARTHROPODS");
	    c.get("EnchantList.18.Name", "Bane of Arthropods");
	    c.get("EnchantList.19.MCName", "KNOCKBACK");
	    c.get("EnchantList.19.Name", "Knockback");
	    c.get("EnchantList.20.MCName", "FIRE_ASPECT");
	    c.get("EnchantList.20.Name", "Fire Aspect");
	    c.get("EnchantList.21.MCName", "LOOT_BONUS_MOBS");
	    c.get("EnchantList.21.Name", "Looting");
	    c.get("EnchantList.32.MCName", "DIG_SPEED");
	    c.get("EnchantList.32.Name", "Efficiency");
	    c.get("EnchantList.33.MCName", "SILK_TOUCH");
	    c.get("EnchantList.33.Name", "Silk Touch");
	    c.get("EnchantList.34.MCName", "DURABILITY");
	    c.get("EnchantList.34.Name", "Unbreaking");
	    c.get("EnchantList.35.MCName", "LOOT_BONUS_BLOCKS");
	    c.get("EnchantList.35.Name", "Fortune");
	    c.get("EnchantList.48.MCName", "ARROW_DAMAGE");
	    c.get("EnchantList.48.Name", "Power");
	    c.get("EnchantList.49.MCName", "ARROW_KNOCKBACK");
	    c.get("EnchantList.49.Name", "Punch");
	    c.get("EnchantList.50.MCName", "ARROW_FIRE");
	    c.get("EnchantList.50.Name", "Flame");
	    c.get("EnchantList.51.MCName", "ARROW_INFINITE");
	    c.get("EnchantList.51.Name", "Infinity");
	    c.get("EnchantList.61.MCName", "LUCK");
	    c.get("EnchantList.61.Name", "Luck of the Sea");
	    c.get("EnchantList.62.MCName", "LURE");
	    c.get("EnchantList.62.Name", "Lure");
	    c.get("EnchantList.70.MCName", "MENDING");
	    c.get("EnchantList.70.Name", "Mending");

	    // Color list
	    c.get("ColorList.0.MCName", "white");
	    c.get("ColorList.0.Name", "&fWhite");
	    c.get("ColorList.1.MCName", "orange");
	    c.get("ColorList.1.Name", "&6Orange");
	    c.get("ColorList.2.MCName", "magenta");
	    c.get("ColorList.2.Name", "&dMagenta");
	    c.get("ColorList.3.MCName", "lightBlue");
	    c.get("ColorList.3.Name", "%9Light blue");
	    c.get("ColorList.4.MCName", "yellow");
	    c.get("ColorList.4.Name", "&eYellow");
	    c.get("ColorList.5.MCName", "lime");
	    c.get("ColorList.5.Name", "&aLime");
	    c.get("ColorList.6.MCName", "pink");
	    c.get("ColorList.6.Name", "&dPink");
	    c.get("ColorList.7.MCName", "gray");
	    c.get("ColorList.7.Name", "&8Gray");
	    c.get("ColorList.8.MCName", "silver");
	    c.get("ColorList.8.Name", "&7Light gray");
	    c.get("ColorList.9.MCName", "cyan");
	    c.get("ColorList.9.Name", "&3Cyan");
	    c.get("ColorList.10.MCName", "purple");
	    c.get("ColorList.10.Name", "&5Purple");
	    c.get("ColorList.11.MCName", "blue");
	    c.get("ColorList.11.Name", "&1Blue");
	    c.get("ColorList.12.MCName", "brown");
	    c.get("ColorList.12.Name", "&4Brown");
	    c.get("ColorList.13.MCName", "green");
	    c.get("ColorList.13.Name", "&2Green");
	    c.get("ColorList.14.MCName", "red");
	    c.get("ColorList.14.Name", "&cRed");
	    c.get("ColorList.15.MCName", "black");
	    c.get("ColorList.15.Name", "&0Black");
	    try {
		c.getW().save(f);
	    } catch (IOException e) {
		e.printStackTrace();
	    }
	}
	readFile();
    }

}
